Attribute VB_Name = "modFlatControls"
Option Explicit

Dim i  As Integer

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Public Type RECT
            Left As Long
            Top As Long
            Right As Long
            Bottom As Long
End Type

Public Declare Function SetWindowPos Lib "user32" _
    (ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal X As Long, _
    ByVal y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long
    
'-------------------Flat Border Const
Public Const GWL_EXSTYLE = (-20)
Public Const WS_EX_WINDOWEDGE = &H100
Public Const WS_EX_CLIENTEDGE = &H200
Public Const WS_EX_STATICEDGE = &H20000

Public Const SWP_NOACTIVATE = &H10
Public Const SWP_NOCOPYBITS = &H100
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOREDRAW = &H8
Public Const SWP_NOOWNERZORDER = &H200
Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Public Const SWP_NOZORDER = &H4
Public Const SWP_FRAMECHANGED = &H20
'-------------------------------------------

Public Sub FlatBorder(ByVal hwnd As Long)

  Dim TFlat As Long

    TFlat = GetWindowLong(hwnd, GWL_EXSTYLE)
    TFlat = TFlat And Not WS_EX_CLIENTEDGE Or WS_EX_STATICEDGE
    SetWindowLong hwnd, GWL_EXSTYLE, TFlat
    SetWindowPos hwnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOZORDER Or SWP_FRAMECHANGED Or SWP_NOSIZE Or SWP_NOMOVE

End Sub

Public Sub FlattenAll(ByVal Frm As Form)

  Dim CTL As Control

    For Each CTL In Frm.Controls
        Select Case LCase(TypeName(CTL))
          Case "commandbutton", "combobox", "textbox", "listbox", "filetree", "treeview", "progressbar", "picturebox", "outlookbar"
        On Error Resume Next
            FlatBorder CTL.hwnd
        End Select
    Next CTL

End Sub

Public Sub Flatten(ByVal Frm As Form)

  Dim CTL As Control

    For Each CTL In Frm.Controls
        Select Case TypeName(CTL)
          Case "CommandButton", "TextBox", "ProgressBar"
            FlatBorder CTL.hwnd
        End Select
    Next CTL

End Sub

Public Sub FlattenSpc(ByVal Frm As Form, TypeN As String)

  Dim CTL As Control

    For Each CTL In Frm.Controls
        Select Case LCase(TypeName(CTL))
          Case LCase(TypeN)
            FlatBorder CTL.hwnd
        End Select
    Next CTL

End Sub
